CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Related Functions
csl::AmbisonicUnitGenerator Class Reference

Ambisonic Abstract Base Class. More...

`#include <Ambisonic.h>`

Inheritance diagram for csl::AmbisonicUnitGenerator:

List of all members.

## Public Member Functions
| AmbisonicUnitGenerator (unsigned order=0)
| Initialize with uniform Ambisonic order. Defaults to zeroth order.
| AmbisonicUnitGenerator (unsigned horder, unsigned vorder)
| Initialize with hybrid Ambisonic order.
| AmbisonicUnitGenerator (AmbisonicOrder order)
virtual | ~AmbisonicUnitGenerator ()
AmbisonicOrder | order ()
unsigned | frameRate ()
void | setFrameRate (unsigned rate)
| get/set the receiver's frame rate
virtual unsigned | numChannels ()
void | setNumChannels (unsigned ch)
| get/set the receiver's number of outputs
BufferCopyPolicy | copyPolicy ()
void | setCopyPolicy (BufferCopyPolicy ch)
| get/set the receiver's buffer copy policy
virtual void | nextBuffer (Buffer &outputBuffer) throw (CException)
| get a buffer of Frames – this is the core CSL "pull" function; the given buffer can be written into, and a changed() message is sent.
virtual void | nextBuffer (Buffer &outputBuffer, unsigned outBufNum) throw (CException)
| really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times
virtual bool | isFixed ()
| query whether I'm fixed (StaticVariable overrides this)
virtual bool | isActive ()
| query whether I'm currently active (Envelopes can go inactive)
void | addOutput (UnitGenerator *ugen)
| add to or return the UGen vector of outputs
void | removeOutput (UnitGenerator *ugen)
UGenVector | outputs ()
virtual unsigned | numOutputs ()
bool | checkFanOut (Buffer &outputBuffer) throw (CException)
| check for fan-out and copy previous buffer; return true if fanning out
void | handleFanOut (Buffer &outputBuffer) throw (CException)
virtual void | setValue (sample theValue)
| set/get the value (not allowed in the abstract, useful for static values)
virtual sample | value ()
virtual void | dump ()
| pretty-print the receiver
virtual void | trigger ()
void | attachObserver (Observer *)
| (possibly notify obersvers on my death)
void | detachObserver (Observer *)
void | changed (void *argument)
| this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map
virtual int | evaluate (void *argument)

## Protected Member Functions
void | setOrder (AmbisonicOrder order)
| Returns the Ambisonic order.
unsigned | channelsToUniformOrder (const unsigned channels)
unsigned | greaterOrder (const AmbisonicOrder order)
| Compares the horizontal and vertical Ambisonic order of a hybrid order and returns the largest.
unsigned | orderToChannels (const AmbisonicOrder order)
| Returns the number of Ambisonic channels from a hybrid Ambisonic order: N = 2*M_h + 1 + (M_v + 1)^2 - (2*M_v + 1)
unsigned | orderToChannels (unsigned order)
| Returns the number of Ambisonic channels corresponding to a uniform Ambisonic order: N = (M+1)^2.
unsigned | orderToHorizontalChannels (const AmbisonicOrder order)
| Returns the number of horizontal Ambisonic channels from a hybrid Ambisonic order: N_h = 2*M_h + 1.
unsigned | orderToVerticalChannels (const AmbisonicOrder order)
| Returns the number of vertical Ambisonic channels from a hybrid Ambisonic order: N_v = (M_v + 1)^2 - (2*M_v + 1)
void | channelIndexer (unsigned *indexArray)
| Calculates a lookup table to map Ambisonic channel index to actually used UnitGenerator channel.
void | invChannelIndexer (unsigned *indexArray)
| Calculates a lookup table to map actually used UnitGenerator channel to Ambisonic channel index.
void | zeroBuffer (Buffer &outputBuffer, unsigned outBufNum)
| utility method to zero out an outputBuffer

## Protected Attributes
AmbisonicOrder | mOrder
| the order of the Unit Generator
unsigned | mFrameRate
| trigger ignored here
unsigned | mNumChannels
| my "expected" number of output channels
BufferCopyPolicy | mCopyPolicy
| the policy I use if asked for more or fewer channels
UGenVector | mOutputs
| the vector of my output UGens
unsigned | mNumOutputs
| the number of outputs
Buffer * | mOutputCache
| my past output ring buffer (only used in case of fan-out)
unsigned | mSequence
| the highest-seen buffer seq number

## Private Member Functions
void | initOrder ()

## Related Functions
(Note that these are not member functions.)
void | singularValueDecomposition (sample **a, int m, int n, sample *w, sample **v)
void | fumaEncodingWeights (SampleBuffer weights, const AmbisonicOrder &order, float azimuth, float elevation)
void | fumaIndexedEncodingWeights (SampleBuffer weights, const AmbisonicOrder &order, sample &azimuth, sample &elevation)

## Detailed Description

Ambisonic Abstract Base Class.

Definition at line 69 of file Ambisonic.h.

## Constructor & Destructor Documentation

AmbisonicUnitGenerator::AmbisonicUnitGenerator | ( | unsigned | order = `0` | ) |

Initialize with uniform Ambisonic order. Defaults to zeroth order.

Definition at line 36 of file Ambisonic.cpp.

References initOrder().

AmbisonicUnitGenerator::AmbisonicUnitGenerator | ( | unsigned | horder,
|  | unsigned | vorder
| ) |  |

Initialize with hybrid Ambisonic order.

Definition at line 40 of file Ambisonic.cpp.

References initOrder(), mOrder, and csl::AmbisonicOrder::verticalOrder.

AmbisonicUnitGenerator::AmbisonicUnitGenerator | ( | AmbisonicOrder | order | ) |

Definition at line 45 of file Ambisonic.cpp.

References initOrder().

AmbisonicUnitGenerator::~AmbisonicUnitGenerator | ( |  | ) |
| virtual

Definition at line 49 of file Ambisonic.cpp.

## Member Function Documentation

AmbisonicOrder csl::AmbisonicUnitGenerator::order | ( |  | ) |
| inline

Definition at line 78 of file Ambisonic.h.

References mOrder.

Referenced by csl::AmbisonicMixer::addInput(), and csl::AmbisonicDecoder::makeTransposedReEncodingMatrix().

void AmbisonicUnitGenerator::setOrder | ( | AmbisonicOrder | order | ) |
| protected

Returns the Ambisonic order.

Definition at line 61 of file Ambisonic.cpp.

References initOrder(), and mOrder.

unsigned AmbisonicUnitGenerator::channelsToUniformOrder | ( | const unsigned | channels | ) |
| protected

Definition at line 68 of file Ambisonic.cpp.

Referenced by csl::AmbisonicDecoder::makeInPhase(), and csl::AmbisonicDecoder::makeMaxRE().

unsigned AmbisonicUnitGenerator::greaterOrder | ( | const AmbisonicOrder | order | ) |
| protected

Compares the horizontal and vertical Ambisonic order of a hybrid order and returns the largest.

Definition at line 73 of file Ambisonic.cpp.

References csl::AmbisonicOrder::horizontalOrder, and csl::AmbisonicOrder::verticalOrder.

Referenced by channelIndexer(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), and csl::AmbisonicDecoder::makeMaxRE().

unsigned AmbisonicUnitGenerator::orderToChannels | ( | const AmbisonicOrder | order | ) |
| protected

Returns the number of Ambisonic channels from a hybrid Ambisonic order: N = 2*M_h + 1 + (M_v + 1)^2 - (2*M_v + 1)

Definition at line 77 of file Ambisonic.cpp.

References csl::AmbisonicOrder::horizontalOrder, and csl::AmbisonicOrder::verticalOrder.

Referenced by channelIndexer(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), initOrder(), and invChannelIndexer().

unsigned AmbisonicUnitGenerator::orderToChannels | ( | unsigned | order | ) |
| protected

Returns the number of Ambisonic channels corresponding to a uniform Ambisonic order: N = (M+1)^2.

Definition at line 82 of file Ambisonic.cpp.

unsigned AmbisonicUnitGenerator::orderToHorizontalChannels | ( | const AmbisonicOrder | order | ) |
| protected

Returns the number of horizontal Ambisonic channels from a hybrid Ambisonic order: N_h = 2*M_h + 1.

Definition at line 87 of file Ambisonic.cpp.

References csl::AmbisonicOrder::horizontalOrder.

unsigned AmbisonicUnitGenerator::orderToVerticalChannels | ( | const AmbisonicOrder | order | ) |
| protected

Returns the number of vertical Ambisonic channels from a hybrid Ambisonic order: N_v = (M_v + 1)^2 - (2*M_v + 1)

Definition at line 92 of file Ambisonic.cpp.

References csl::AmbisonicOrder::verticalOrder.

void AmbisonicUnitGenerator::channelIndexer | ( | unsigned * | indexArray | ) |
| protected

Calculates a lookup table to map Ambisonic channel index to actually used UnitGenerator channel.

Definition at line 100 of file Ambisonic.cpp.

References greaterOrder(), csl::AmbisonicOrder::horizontalOrder, mOrder, orderToChannels(), and csl::AmbisonicOrder::verticalOrder.

Referenced by csl::AmbisonicRotator::initialize(), and csl::AmbisonicDecoder::initialize().

void AmbisonicUnitGenerator::invChannelIndexer | ( | unsigned * | indexArray | ) |
| protected

Calculates a lookup table to map actually used UnitGenerator channel to Ambisonic channel index.

Definition at line 148 of file Ambisonic.cpp.

References csl::AmbisonicOrder::horizontalOrder, mOrder, orderToChannels(), and csl::AmbisonicOrder::verticalOrder.

Referenced by csl::AmbisonicDecoder::initialize().

void AmbisonicUnitGenerator::initOrder | ( |  | ) |
| private

Definition at line 52 of file Ambisonic.cpp.

References csl::AmbisonicOrder::horizontalOrder, csl::AmbisonicOrder::isUniform, csl::kIgnore, csl::UnitGenerator::mNumChannels, mOrder, orderToChannels(), csl::UnitGenerator::setCopyPolicy(), and csl::AmbisonicOrder::verticalOrder.

Referenced by AmbisonicUnitGenerator(), and setOrder().

unsigned csl::UnitGenerator::frameRate | ( |  | ) |
| inline inherited

Definition at line 225 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), csl::SoundCue::dump(), csl::Filter::init(), csl::SndFileInstrument::playNote(), and csl::SndFileInstrument::playOSC().

void csl::UnitGenerator::setFrameRate | ( | unsigned | rate | ) |
| inline inherited

get/set the receiver's frame rate

Definition at line 226 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by m3_header().

virtual unsigned csl::UnitGenerator::numChannels | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::Splitter, and csl::Stereoverb.

Definition at line 228 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::AmbisonicMixer::addInput(), csl::BlockResizer::BlockResizer(), csl::Port::checkBuffer(), csl::Effect::Effect(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), m3_output(), csl::Mixer::nextBuffer(), and csl::SpatialSource::SpatialSource().

void csl::UnitGenerator::setNumChannels | ( | unsigned | ch | ) |
| inline inherited

get/set the receiver's number of outputs

Definition at line 229 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::BinauralPanner::BinauralPanner(), m3_output(), csl::Spatializer::Spatializer(), csl::VBAP::speakerLayoutChanged(), and csl::VBAP::VBAP().

BufferCopyPolicy csl::UnitGenerator::copyPolicy | ( |  | ) |
| inline inherited

Definition at line 231 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

void csl::UnitGenerator::setCopyPolicy | ( | BufferCopyPolicy | ch | ) |
| inline inherited

get/set the receiver's buffer copy policy

Definition at line 232 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

Referenced by csl::AmbisonicPanner::AmbisonicPanner(), csl::BinauralPanner::BinauralPanner(), initOrder(), csl::Noise::Noise(), csl::PinkNoise::PinkNoise(), csl::Spatializer::Spatializer(), and csl::VBAP::VBAP().

void UnitGenerator::nextBuffer | ( | Buffer & | outputBuffer | ) | throw (CException)
| virtual inherited

get a buffer of Frames – this is the core CSL "pull" function; the given buffer can be written into, and a changed() message is sent.

Reimplemented in csl::Joiner, csl::Splitter, csl::FanOut, csl::SoundCue, csl::Stereoverb, csl::StereoWidth, csl::Abst_SoundFile, csl::NtoMPanner, csl::RemoteStream, csl::LSoundFile, csl::BufferStream, csl::GrainPlayer, csl::Panner, csl::RingBuffer, csl::Instrument, csl::VBAP, csl::IFFT, csl::SpatialSource, csl::BinauralPanner, csl::InOut, csl::Spatializer, csl::Mixer, csl::SpatialPanner, csl::DecodedFile, csl::RingBufferTap, csl::AmbisonicPanner, csl::BlockResizer, csl::FFT, csl::DelayLine, csl::SimplePanner, csl::SimplePanner, and csl::Microphone.

Definition at line 576 of file CSL_Core.cpp.

References csl::kCopy, csl::kExpand, csl::kIgnore, csl::logMsg(), and memcpy().

Referenced by csl::DistanceSimulator::nextBuffer(), csl::RingBufferTap::nextBuffer(), csl::Mixer::nextBuffer(), csl::AmbisonicMixer::nextBuffer(), csl::SpatialSource::nextBuffer(), csl::BufferStream::nextBuffer(), csl::Controllable::pullInput(), csl::PAIO::test(), and csl::FileIO::writeNextBuffer().

void UnitGenerator::nextBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  | throw (CException)
| virtual inherited

really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times

Reimplemented in csl::Joiner, csl::Splitter, csl::FanOut, SAFliter, csl::RandEnvelope, csl::Moog, csl::AmbisonicDecoder, csl::Impulse, csl::Square, csl::AmbisonicEncoder, csl::Sawtooth, csl::FSine, csl::MulOp, csl::Envelope, csl::Sine, csl::DynamicVariable, csl::Filter, csl::AmbisonicRotator, csl::CompOrCacheOscillator, csl::BufferStream, csl::AddOp, csl::FIR, csl::WavetableOscillator, csl::PinkNoise, csl::VBAP, csl::RtpReceiver, csl::SineAsScaled, csl::SpatialSource, csl::LineSegment, csl::StaticVariable, csl::AmbisonicMixer, csl::WhiteNoise, csl::SineAsPhased, csl::SpatialPanner, csl::Window, csl::RingBufferTap, csl::BinaryOp, csl::Freeverb, csl::KarplusString, csl::RtpSender, csl::Clipper, csl::Lorenz, csl::SimpleSine, csl::DistanceSimulator, and csl::WaveShaper.

Definition at line 605 of file CSL_Core.cpp.

virtual bool csl::UnitGenerator::isFixed | ( |  | ) |
| inline virtual inherited

query whether I'm fixed (StaticVariable overrides this)

Reimplemented in csl::StaticVariable, and csl::BinaryOp.

Definition at line 247 of file CSL_Core.h.

virtual bool csl::UnitGenerator::isActive | ( |  | ) |
| inline virtual inherited

query whether I'm currently active (Envelopes can go inactive)

Reimplemented in csl::Joiner, csl::Effect, csl::RandEnvelope, csl::SoundCue, csl::Stereoverb, csl::Abst_SoundFile, csl::Envelope, csl::Instrument, csl::Mixer, and csl::KarplusString.

Definition at line 249 of file CSL_Core.h.

Referenced by csl::Instrument::isActive(), csl::Port::isActive(), csl::Mixer::nextBuffer(), csl::BinauralPanner::nextBuffer(), csl::AmbisonicMixer::nextBuffer(), and csl::VBAP::nextBuffer().

void UnitGenerator::addOutput | ( | UnitGenerator * | ugen | ) |
| inherited

add to or return the UGen vector of outputs

Definition at line 520 of file CSL_Core.cpp.

References csl::Buffer::allocateBuffers(), csl::CGestalt::maxBufferFrames(), csl::UnitGenerator::mNumOutputs, csl::UnitGenerator::mOutputCache, and csl::UnitGenerator::mOutputs.

Referenced by csl::Mixer::addInput(), csl::Controllable::addInput(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicEncoder::setInput(), and csl::IO::setRoot().

void UnitGenerator::removeOutput | ( | UnitGenerator * | ugen | ) |
| inherited

Definition at line 530 of file CSL_Core.cpp.

References csl::UnitGenerator::mNumOutputs, and csl::UnitGenerator::mOutputs.

Referenced by csl::IO::clearRoot(), csl::AmbisonicEncoder::setInput(), csl::AmbisonicDecoder::~AmbisonicDecoder(), and csl::AmbisonicRotator::~AmbisonicRotator().

UGenVector csl::UnitGenerator::outputs | ( |  | ) |
| inline inherited

Definition at line 253 of file CSL_Core.h.

References csl::UnitGenerator::mOutputs.

virtual unsigned csl::UnitGenerator::numOutputs | ( |  | ) |
| inline virtual inherited

Definition at line 254 of file CSL_Core.h.

References csl::UnitGenerator::mNumOutputs.

bool UnitGenerator::checkFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

check for fan-out and copy previous buffer; return true if fanning out

Definition at line 549 of file CSL_Core.cpp.

void UnitGenerator::handleFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

Definition at line 563 of file CSL_Core.cpp.

References csl_max.

virtual void csl::UnitGenerator::setValue | ( | sample | theValue | ) |
| inline virtual inherited

set/get the value (not allowed in the abstract, useful for static values)

Reimplemented in csl::DynamicVariable, and csl::StaticVariable.

Definition at line 260 of file CSL_Core.h.

virtual sample csl::UnitGenerator::value | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::StaticVariable.

Definition at line 261 of file CSL_Core.h.

void UnitGenerator::dump | ( | void |  | ) |
| virtual inherited

pretty-print the receiver

Reimplemented in csl::RandEnvelope, csl::SumOfSines, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::Filter, csl::VBAP, csl::SineAsScaled, csl::LineSegment, csl::SpatialSource, csl::SineAsPhased, csl::Mixer, csl::Window, csl::KarplusString, csl::Oscillator, csl::AmbisonicPanner, csl::BinaryOp, csl::Lorenz, csl::Clipper, csl::CASoundFile, and csl::Noise.

Definition at line 543 of file CSL_Core.cpp.

References csl::logMsg(), and csl::UnitGenerator::mOutputs.

Referenced by csl::Port::dump(), dumpTest(), and testSimpleSines().

virtual void csl::UnitGenerator::trigger | ( | void |  | ) |
| inline virtual inherited

Reimplemented in csl::Joiner, csl::Effect, csl::RandEnvelope, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::LineSegment, and csl::KarplusString.

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Instrument::play(), csl::Instrument::release(), and csl::Port::trigger().

void UnitGenerator::zeroBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  |
| protected inherited

utility method to zero out an outputBuffer

Definition at line 513 of file CSL_Core.cpp.

References csl::Buffer::mMonoBufferByteSize, and csl::Buffer::monoBuffer().

void Model::attachObserver | ( | Observer * | o | ) |
| inherited

(possibly notify obersvers on my death)

register/remove observers

Definition at line 491 of file CGestalt.cpp.

References csl::logMsg(), csl::Observer::mKey, and csl::Observer::mPeriod.

Referenced by csl::SpatialPanner::setSpeakerLayout().

void Model::detachObserver | ( | Observer * | o | ) |
| inherited

Definition at line 507 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::~SpatialPanner().

void Model::changed | ( | void * | argument | ) |
| inherited

this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map

Definition at line 529 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpeakerLayout::addSpeaker(), csl::MIDIIn::handleIncomingMidiMessage(), and csl::SpeakerLayout::setDefaultSpeakerLayout().

virtual int csl::Model::evaluate | ( | void * | argument | ) |
| inline virtual inherited

Reimplemented in csl::MIDIIn.

Definition at line 259 of file CGestalt.h.

## Friends And Related Function Documentation

void singularValueDecomposition | ( | sample ** | a,
|  | int | m,
|  | int | n,
|  | sample * | w,
|  | sample ** | v
| ) |  |
| related

Given a matrix a[m][n], this routine computes its singular value decomposition, A = U*W*V^{T}. The matrix U replaces a on output. The diagonal matrix of singular values W is output as a vector w[n]. The matrix V (not the transpose V^{T}) is output as v[n][n]. m must be greater or equal to n; if it is smaller, then a should be filled up to square with zero rows.

Definition at line 627 of file AmbisonicUtilities.cpp.

References MAX, PYTHAG, and SIGN.

Referenced by csl::AmbisonicDecoder::asPseudoInverse().

void fumaEncodingWeights | ( | SampleBuffer | weights,
|  | const AmbisonicOrder & | order,
|  | float | azimuth,
|  | float | elevation
| ) |  |
| related

Definition at line 865 of file AmbisonicUtilities.cpp.

References csl::AmbisonicOrder::horizontalOrder, and csl::AmbisonicOrder::verticalOrder.

Referenced by csl::AmbisonicDecoder::makeTransposedReEncodingMatrix().

void fumaIndexedEncodingWeights | ( | SampleBuffer | weights,
|  | const AmbisonicOrder & | order,
|  | sample & | azimuth,
|  | sample & | elevation
| ) |  |
| related

Definition at line 930 of file AmbisonicUtilities.cpp.

References csl::AmbisonicOrder::horizontalOrder, and csl::AmbisonicOrder::verticalOrder.

## Member Data Documentation

AmbisonicOrder csl::AmbisonicUnitGenerator::mOrder
| protected

the order of the Unit Generator

Definition at line 83 of file Ambisonic.h.

Referenced by csl::AmbisonicMixer::addInput(), AmbisonicUnitGenerator(), channelIndexer(), csl::AmbisonicMixer::initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), initOrder(), invChannelIndexer(), csl::AmbisonicDecoder::makeTransposedReEncodingMatrix(), order(), csl::AmbisonicRotator::rotateFirstOrderHorizontal(), csl::AmbisonicRotator::rotateSecondOrderHorizontal(), csl::AmbisonicRotator::rotateSecondOrderVertical(), setOrder(), csl::AmbisonicRotator::setTilt(), and csl::AmbisonicRotator::setTumble().

unsigned csl::UnitGenerator::mFrameRate
| protected inherited

trigger ignored here

the frame rate – initialized to be the default by the constructor

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::RtpSender::createRtpSession(), csl::RtpReceiver::createRtpSession(), csl::Lorenz::dump(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::Filter::init(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::RandEnvelope::nextSegment(), csl::SquareBL::nextWaveInto(), csl::SumOfSines::nextWaveInto(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::DelayLine::setDelayTime(), csl::UnitGenerator::setFrameRate(), csl::Abst_SoundFile::setStartSec(), csl::Abst_SoundFile::setStopSec(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Moog::setupCoeffs(), and csl::DecodedFile::writeBuffer().

unsigned csl::UnitGenerator::mNumChannels
| protected inherited

my "expected" number of output channels

Definition at line 268 of file CSL_Core.h.

Referenced by csl::AmbisonicMixer::addInput(), csl::Mixer::allocateOpBuffer(), csl::AmbisonicDecoder::asProjection(), csl::AmbisonicDecoder::asPseudoInverse(), csl::BlockResizer::BlockResizer(), csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::checkBuffer(), csl::DecodedFile::checkBufferStack(), csl::FMInstrument::FMInstrument(), csl::GrainPlayer::GrainPlayer(), csl::AdditiveInstrument::init(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::AmbisonicMixer::initialize(), csl::SndFileInstrument::initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicEncoder::initialize(), csl::AmbisonicDecoder::initialize(), initOrder(), csl::RemoteStream::initPacket(), csl::Joiner::isActive(), csl::AmbisonicDecoder::makeInPhase(), csl::AmbisonicDecoder::makeMaxRE(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), csl::Mixer::Mixer(), csl::UnitGenerator::numChannels(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::Panner::Panner(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RemoteStream::RemoteStream(), csl::UnitGenerator::setNumChannels(), csl::WavetableOscillator::setWaveform(), csl::Joiner::trigger(), csl::DecodedFile::writeBuffer(), and csl::AmbisonicRotator::~AmbisonicRotator().

BufferCopyPolicy csl::UnitGenerator::mCopyPolicy
| protected inherited

the policy I use if asked for more or fewer channels

Definition at line 269 of file CSL_Core.h.

Referenced by csl::UnitGenerator::copyPolicy(), and csl::UnitGenerator::setCopyPolicy().

UGenVector csl::UnitGenerator::mOutputs
| protected inherited

the vector of my output UGens

Definition at line 270 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::dump(), csl::UnitGenerator::outputs(), and csl::UnitGenerator::removeOutput().

unsigned csl::UnitGenerator::mNumOutputs
| protected inherited

the number of outputs

Definition at line 271 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::numOutputs(), and csl::UnitGenerator::removeOutput().

Buffer* csl::UnitGenerator::mOutputCache
| protected inherited

my past output ring buffer (only used in case of fan-out)

Definition at line 272 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput().

unsigned csl::UnitGenerator::mSequence
| protected inherited

the highest-seen buffer seq number

Definition at line 273 of file CSL_Core.h.

The documentation for this class was generated from the following files:

- CSL/Spatializers/Ambisonic/Ambisonic.h
- CSL/Spatializers/Ambisonic/Ambisonic.cpp
- CSL/Spatializers/Ambisonic/AmbisonicUtilities.cpp